import 'dart:async';

import 'package:captain/captain.dart';
import 'package:flutter/widgets.dart';

class CaptainDispatcher extends StatefulWidget {
  const CaptainDispatcher({
    required this.dispatcherStream,
    required this.child,
  });

  final Stream<List<Page> Function(List<Page>)> dispatcherStream;
  final Widget child;

  @override
  _CaptainDispatcherState createState() => _CaptainDispatcherState();
}

class _CaptainDispatcherState extends State<CaptainDispatcher> {
  Captain? _captain;
  late StreamSubscription<List<Page<dynamic>> Function(List<Page<dynamic>>)>
      _dispatcherStreamSubscription;

  @override
  void initState() {
    super.initState();
    _dispatcherStreamSubscription =
        widget.dispatcherStream.listen((_dispatcher) {
      _captain = Captain.of(context);
      if (_captain != null) {
        _captain!.config.invokeActionFunc(_dispatcher);
      }
    });
  }

  @override
  void dispose() {
    _dispatcherStreamSubscription.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return widget.child;
  }
}
