import 'package:captain/captain.dart';
import 'package:flutter/material.dart';

extension GetCaptain on NavigatorState {
  /// invoke an action on Captain with the actionKey object
  void action(dynamic actionKey) {
    return Captain.of(this.context)?.config.invokeAction(actionKey);
  }

  /// invoke a custom actionFunc on Captain with providing a function that takes a List<Page> as input and returns a List<Page> which will be the new page stack
  void actionFunc(
    List<Page> Function(List<Page> pageStack) actionFunc, {
    dynamic? registerWithFollowingKey,
  }) {
    if (registerWithFollowingKey != null) {
      final _captain = Captain.of(this.context);
      if (_captain != null) {
        _captain.config.upsertAction(actionFunc, registerWithFollowingKey);
      } else {
        throw Exception("no instance of Captain found");
      }
    }
    return Captain.of(this.context)?.config.invokeActionFunc(actionFunc);
  }
}
